Тёмный

Coin Change 

Kevin Naughton Jr.
Подписаться 138 тыс.
Просмотров 154 тыс.
50% 1

Опубликовано:

 

23 окт 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 190   
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
What question should I cover next?
@MohammedJavid-jz8vi
@MohammedJavid-jz8vi 5 лет назад
Sir please try to cover questions related to binary trees👍
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
@@ismailelhabbash I'll add that to my list!
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
@@MohammedJavid-jz8vi You've got it Javid!
@kuppurajkarthik
@kuppurajkarthik 5 лет назад
Can you do Word Squares and Sliding window maximum?
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
@@kuppurajkarthik I'll add it to my list! Do you have the problem numbers?
@BABEENGINEER
@BABEENGINEER 4 года назад
Would be cool if after you coded the solution you can loop through the program with illustration. For example incrementing variables and drawing out what arrays look like, how they change when we go through loops, etc. It would be helpful since not everyone codes in Java and it makes it easier to understand. Not having to figure out what does "Arrays.fill(dp, amount + 1)" look like: Does it look like [11], does it look like [11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11]? So just some syntax things in other languages that slow learning down could be fixed.
@CASLOAcademy
@CASLOAcademy 2 года назад
you should pay him to do that. he is not your slave....
@Karan-zk9ke
@Karan-zk9ke Год назад
i was also trying to figure that out ,Arrays.fill(dp, amount + 1) will populate the array with max val (i.e amount+1) , cuz even the smallest denomination (1) need "amount" no. of coins i.e
@pmolchanov2002
@pmolchanov2002 4 года назад
I like how you are using a bottom-up approach to DP instead of recursion. It makes your code much cleaner and simple!
@kuppurajkarthik
@kuppurajkarthik 5 лет назад
Your solutions always make it look so simple compared to Leetcode or GeeksforGeeks. Great work!!
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
Thanks Kuppuraj I'm happy to hear my explanations are helpful :)
@notwhoyouthink666
@notwhoyouthink666 5 лет назад
His solutions are just copy-paste from solution tab on leetcode.
@pradeepkumar-qo8lu
@pradeepkumar-qo8lu 5 лет назад
@@notwhoyouthink666 doesn't matter, he's explaining it in a matter that is digestible for Noobs like me
@abdoulbarry6929
@abdoulbarry6929 4 года назад
Ikrrrrrrrrrrrr....this gives me faith to keep working on my skills!!! Such a great teacher
@jameysiddiqui6910
@jameysiddiqui6910 3 года назад
@@notwhoyouthink666 u can also do the same, please try to appreciate someone's effort instead of negativity.
@JohnWick-ep7qr
@JohnWick-ep7qr 4 года назад
Great videos Kevin. Just a note on a very small optimization - Since you already calculated dp[0] = 0, you can loop from i = 1, instead of i = 0;
@KevinNaughtonJr
@KevinNaughtonJr 4 года назад
thanks John and yes nice catch!
@joetxca
@joetxca 2 года назад
Line 17, "dp[amount] > amount ? -1 : dp[amount]" does dp[amount] > amount comparable?
@pvsk10
@pvsk10 3 года назад
Instead of saying ' believe it or not it works", consider adding an explanation of why this works in more detail. Thank you for your videos 😊
@Nikhil-gm8ks
@Nikhil-gm8ks 5 лет назад
Would be nice to see some solution in C++ too. Also something like breaking down video into: Understanding Problem, Sudo code, Discussing different solution and which one most efficient ( some what like most white board interviews will be like ) and then diving into coding part. Also a video for beginners to get a walk through Leetcode and such platform. Because for some who recently just learnt coding,Algo and Data structure, it can be difficult to understand how to even understand the example, output, input etc. Thanks
@abzzz4u
@abzzz4u 4 года назад
How come you make it look so easy? Genius.
@adityagupta375
@adityagupta375 3 года назад
question .........1)put coins in a max heap 2)curr=pull out the head of heap(max coin) to_ret=0 3)Find n where n*curr is greatest multiple of curr smaller than amount 4)to_ret +=n 5) repeat steps 2 to 4 till heap is empty 6)return to_ret why cant we do this?
@shobananatesan
@shobananatesan 5 лет назад
Hi Kevin!All your videos are straight right to the point and solutions are easy to understand.Thanks much.Would you do a solution video for Word Ladder ll problem in Leetcode?
@rahuljain5642
@rahuljain5642 3 года назад
It would have taken more than 1 hour if I didn't refer to your explanation. You have explained it so well, it took only 15 minutes. Thanks a lot, @Kevin Naughton Jr. Love from India
@joelogtheta640
@joelogtheta640 4 года назад
You could loop trough the coins as outer for and avoid to check i is less than the value: for (const auto& coin: coins) for (int i =coin ; i < amount+1; ++i) dp[i]=min(dp[i], 1 + dp[i - coin]);
@lawrencejustin8136
@lawrencejustin8136 4 года назад
Hi Kevin, do you have a playlist of all your dynamic programming leetcode solutions?
@alisazhila4458
@alisazhila4458 3 года назад
What a dedication to teaching, almost losing breath! The video is much appreciated though! :)
@Saikumar-kb4lf
@Saikumar-kb4lf 3 года назад
The new easy and intuitive way i found with nearly O(n) time complexity is 1) First sort array in O(nlogn) using merge sort 2) Fewer coins will be used, if coin value is high. So come from back and then decrease one by one element in array..max O(n)
@gcash49
@gcash49 2 года назад
this wudnt pass all test cases for this problem
@sandarabian
@sandarabian 4 года назад
Can you explain line 9 a little more? Isn't it possible that dp[i - coins[j]] produces a negative index? Also, dp[i] should just give us the answer for each i right? Why are we looking up the index in dp based on the value of a coin?
@trintron65
@trintron65 4 года назад
i - coins[j] will never be negative, because there is a condition check (coin[j]
@fsfdsdfdsfsdf
@fsfdsdfdsfsdf 5 лет назад
How do you identify if a problem needs dp? I'm a complete beginner to dp and I have trouble figuring out when the problem calls for it. Thanks for the video!
@samarpanharit4268
@samarpanharit4268 5 лет назад
As far as i know , DP is mainly used for optimisation problems(minimisation or maximising) .
@harrisonlu8532
@harrisonlu8532 5 лет назад
If your problem has subproblems (you have to solve smaller problems first in order to solve the larger problem), you can use DP. In general, if you think "hey, this problem can be solved with recursion," consider whether it can be solved with DP and memoization first.
@zustaz
@zustaz 3 года назад
Thanks for a great video! Why we can't use greedy approach here?
@RenatoFontes
@RenatoFontes 2 года назад
Took me a while to understand but the solution is perfect. Thanks!
@AnkitMishra-xu6ef
@AnkitMishra-xu6ef 5 лет назад
Sir, Your solutions are always very easy to understand compared to the other online resources. Thanks for it.
@vernon_4411
@vernon_4411 4 года назад
How about this approach? Sorting the coins in the reverse order from the largest to the smallest and walking over the sorted array to do division and modulus operations.
@mrodg
@mrodg 4 года назад
This wouldn't work don't waste your time.
@ariellyrycs
@ariellyrycs 4 года назад
i tryied that approach, but it timed out.
@anisharbi3510
@anisharbi3510 4 года назад
That's a reasonable first intuition, but it won't work cause you won't necessarily use the largest coins. Imagine the following case: amount = 8, coins = [2,5]. it will return -1. where as it should return 4.
@pjamestx
@pjamestx 4 года назад
@@anisharbi3510 The modulus approach will work with your example, in that you will sort your available coins as [5, 2]: it will see that it needs zero of the 5 coins, and two of the 2 coins. The place where this approach fails is if you have coins of [10, 8, 1], and you need to get to 16, the modulus approach will first take a 10 coin, then zero 8's, and six 1's, whereas the correct approach would be to take two 8's.
@budguesor9222
@budguesor9222 3 года назад
@@pjamestx The amount is 8 not 4 for the example anis gave.
@barkhabajaj5596
@barkhabajaj5596 3 года назад
Hi Kevin, Can you please add Snake and Ladders problem. I know its an easy one, but like to see your approach. Thanks
@CyberMew
@CyberMew 3 года назад
Good explanation, but you should also mentioned why you picked (amount + 1) as your default invalid instead of say Integer.Max. Because it seems like Integer.Max works fine too? I don't see how it would overflow or such. Please correct me if this is incorrect.
@EchoVids2u
@EchoVids2u 4 года назад
I like your solutions but It would be nice as well if you could draw it out on the screen with the table and all. Hearing the solution verbally is hard for me to follow along.
@vk1618
@vk1618 4 года назад
Bottom up approach + optimization by removing obvious no-fits
@stage666
@stage666 3 года назад
If the interviewer allows a coin to be 0.5 cents, then the arrays.fill(dp, amount+1) would be wrong right? What is a good value to initialize it to then?
@jadenwatt1977
@jadenwatt1977 2 года назад
how do you come up with this, inspirational fr lmao
@reallylordofnothing
@reallylordofnothing 5 месяцев назад
This is a great video to understand. If you keep it currency agnostic, it's better because people outside the US really get confused with examples of nickels and cents.
@joetxca
@joetxca 2 года назад
Line 17, "dp[amount] > amount ? -1 : dp[amount]" does dp[amount] > amount comparable?
@ermattson
@ermattson 5 лет назад
Thanks so much for your videos, Kevin! They're super helpful and I really enjoy watching them. I would love to chat with you about some interviews I have coming up in Microsoft.
@ariellyrycs
@ariellyrycs 4 года назад
I would like to know your top process to realize that it's more efficient to loop tru amount instead of making combinations of coins. i tried every BFS, DFS and dividing recursively but it timed out.
@williamalexander5371
@williamalexander5371 4 года назад
Ariel robles alvarez the cheeky way is to look at the given parameters of the problem. If we build up to amount and try all coins, we have coins*amount complexity. By contrast, pure recursion could have 2^n complexity since we are deciding each time whether or not we accept a coin. We need to take advantage of the fact that we know our amount and to shrink the goal of getting that amount until it equals the base case of a single coin
@AbhishekRanjanUIUC
@AbhishekRanjanUIUC 4 года назад
Super happy to find your channel. It helped me a lot man. Thanks for that. Is it possible for you to do word permutations and minimum sub sequence DP problems please?
@KevinNaughtonJr
@KevinNaughtonJr 4 года назад
Thanks and I'll see what I can do!
@neerajkumar1993
@neerajkumar1993 4 года назад
You good man..you good! Struggled with this guy for a lil
@angrwl
@angrwl 4 года назад
great solution but don't we need to account for the fact if amount is less than any coin in coins? Surely that should return -1 but your code will lead to an error?
@KelleyKouture
@KelleyKouture 4 года назад
this is a FANTASTIC explanation!!! thank you so much!!!
@KevinNaughtonJr
@KevinNaughtonJr 4 года назад
anytime Alyssa and thanks!
@playanakobi4407
@playanakobi4407 3 года назад
One problem I always get when solving these is how do I get the subproblem. Thank you for this!
@pegahfallah3770
@pegahfallah3770 3 года назад
first video of this problem that i actually understood ty
@sateeshtata
@sateeshtata 5 лет назад
Love the explanation and the optimization tip in the end. Thanks for making the video.
@rufortian1084
@rufortian1084 4 года назад
Thank you so much, these explanations are really great!
@calfland79
@calfland79 4 года назад
In line 9, why it is 1 + dp[i - coins[j]. In other words, how do you know only take 1 of coins[j], not 2, 3, or 4.
@iPoopDinosaurs
@iPoopDinosaurs 4 года назад
calfland79 because that is stored in an earlier index in the dp array. Example: you have coins {1, 5} and you want to make amount of 11. Of course, this will take 3 coins. At dp[11], on line 9, you’d have 1 + dp[11-5] = dp[6]. At dp[6], you have 1 + dp[1]==1 (so dp[6] == 2), so dp[11]==3. The two nickels were accounted for at dp[11] and dp[6]
@jonfit2392
@jonfit2392 4 года назад
@@iPoopDinosaurs Got it. Thanks.
@nnelg.t1232
@nnelg.t1232 3 года назад
This dude is gold
@SelftaughtSoftwareEngineer
@SelftaughtSoftwareEngineer 4 года назад
Why aren't you at FAANG yet? Really like your simple yet thorough explanation! Thanks for the great videos!
@vaichegodas
@vaichegodas 4 года назад
you need to be able to reproduce this quality in a interview with random questions not study it beforehand and record a 10min video
@codegeek8256
@codegeek8256 2 года назад
So you understand his explanation?
@phouthasakinit
@phouthasakinit 4 года назад
Question regarding that optimization step, because you used Arrays.sort(), would you add the sort's time complexity to the final time complexity analysis? Why or why not?
@olakunleism
@olakunleism 4 года назад
not really, because sort would take O(nlongn) which is smaller than O(n*m) hence it would still be O(n * m)
@विशालकुमार-छ7त
No need to sort in this question. But complexity will be still same O(n*amount)
@alex.perreras
@alex.perreras 3 года назад
1. dp - is a bad name for array of number min coins for each value 2. first loop should start from 1 not 0 - this is redundant iteration
@machsleep
@machsleep 2 года назад
Thank you. Simple and clearly explained.
@bestplatformtoearnfastbolt9582
@bestplatformtoearnfastbolt9582 2 года назад
👆🏼
@PedroGrilo13
@PedroGrilo13 3 года назад
Very helpful. Thank you for your videos!
@undergraddeveloper1130
@undergraddeveloper1130 4 года назад
I have a question. What stops me from just saying I want to iterate through the array and go backwards and just keep filling the maximum denomination everytime.
@ParitoshPotukuchi
@ParitoshPotukuchi 4 года назад
{1,3,4,5} and sum=7. do it yourself!!!
@adi_sekar
@adi_sekar 5 лет назад
Hi Kevin! Thanks for your videos. But how does this work for [2] coins, and amount = 3 ? It will return min coins as 1, but it should be -1. Can you explain?
@vaishnavibollaboina6620
@vaishnavibollaboina6620 4 года назад
Are these questions good for machine learning interviews or business analyst interviews too ?
@walidzein1
@walidzein1 3 года назад
these questions are too retarded to be asked for any type for interview
@BadriBlitz
@BadriBlitz 3 года назад
Very Well Explained.Thanks bro.
@pauleaggymandengue3135
@pauleaggymandengue3135 4 года назад
i enjoyed watching this ! thanks so much for sharing it is well explained
@nosoyyotampoco
@nosoyyotampoco 4 года назад
Hi Kevin, could you post more videos about DP?
@son0funiverse
@son0funiverse 2 года назад
I don't get it Amazon boy. please help
@alamjim6117
@alamjim6117 5 лет назад
What a underrated channel?!!!
@zoufishanmehdi
@zoufishanmehdi 5 лет назад
Hi Kevin! Thank you for the videos- they have been super helpful as I do interview prep. I became a patreon member recently and would love to get an invitation to your discord channel and perhaps setup a time to chat.
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
Hey Zoufishan! I just saw that, I'm sending you an invite now :)
@aviroxi
@aviroxi 3 года назад
really i don't know what leetcode is but after watching this video i am addicted to it thank you so much
@sunwoodad
@sunwoodad 5 лет назад
Hi Kevin, could you check the "Find the celebrity" video you posted before? It seems broken.
@fabiocosta3003
@fabiocosta3003 4 года назад
good explanation, Kevin! You are the best
@piglets_1992
@piglets_1992 5 лет назад
Hey Kevin! Thanks for the video. Can you please explain why at line 9, number 1 is added?
@harrisonlu8532
@harrisonlu8532 5 лет назад
Because you're adding one additional coin to tally up from the previous solution, which was (amount - 1)
@ariellyrycs
@ariellyrycs 4 года назад
because the arre to store the result is 0 based.
@codegeek8256
@codegeek8256 2 года назад
@@ariellyrycs What does 0 based mean?
@codegeek8256
@codegeek8256 2 года назад
@@harrisonlu8532 I still dont get it.
@Artificial_Intelligence_AI
@Artificial_Intelligence_AI 4 года назад
for int i = 0 makes no sense because you already solved that subproblem. You should start iterating at i = 1. BTW your videos are awesome. Thank you for all of them :D
@knight_23
@knight_23 4 года назад
I was also thinking the same
@caesar5555
@caesar5555 4 года назад
ammm no.... why wont you sort the array in descending order and for each i do amount/arr[i] = a and amount MOD arr[i] = b and so on... Much faster
@quangvo4563
@quangvo4563 4 года назад
Why do we have to have the "+1" at dp[i] = Min(dp[i], 1 + dp[i-coins[j]]
@rongav1997
@rongav1997 4 года назад
so the dp array is essentially the least number of coins at that array so if amt = 2 then dp[2] would be minimum coins at that point. In our case, the 1+ dp[i - coins[j]] can be thought of as taking an extra coin so in the case of dp[3], you would be adding 1 + dp[3 - 2]
@rickvideoone
@rickvideoone 4 года назад
because we are taking "1" coin of value: coin[j].
@ketulshah5283
@ketulshah5283 3 года назад
I still didn't understand login on line number 9. Can someone explain deeper?
@jmackultra
@jmackultra 4 года назад
I actually got asked this question, or one really close to it rather, in an interview the other day.
@kavishpahade1337
@kavishpahade1337 4 года назад
which company?
@jmackultra
@jmackultra 4 года назад
Kavish Pahade SnapDocs
@shiva_bhusal
@shiva_bhusal 4 года назад
Great explanation! Thank you, Kevin.
@KevinNaughtonJr
@KevinNaughtonJr 4 года назад
Thanks Shiva and anytime!
@sleepingguru3243
@sleepingguru3243 3 года назад
Could you add graph related problem
@krithickkrishnagiri6371
@krithickkrishnagiri6371 3 года назад
Great video and nice explanation. Made it very simple
@nasirkhansirajbhai8016
@nasirkhansirajbhai8016 Год назад
can someone pls explain line # 9, I still didn't get it
@hanif3661
@hanif3661 2 года назад
why 1 + ? . That’s important i think
@swethavarnaau7619
@swethavarnaau7619 4 года назад
Thank you so much for this video. ur the best kevin.
@MohammedJavid-jz8vi
@MohammedJavid-jz8vi 5 лет назад
Nice explanation sir thank you👍😊
@KevinNaughtonJr
@KevinNaughtonJr 5 лет назад
Thanks Javid! :)
@lifeofme3172
@lifeofme3172 3 года назад
Why do we do amount + 1?
@ShailPanchal
@ShailPanchal 4 года назад
If this question asked in the interview, should we give the overview of recursion first or can we get started by dp?
@alicebobson2868
@alicebobson2868 4 года назад
id give quick explanation of recursion and then do dp and explain why you chose dp over recursion
@ShailPanchal
@ShailPanchal 4 года назад
@@alicebobson2868 Thanks
@manikandantv3015
@manikandantv3015 5 лет назад
@Kevin, can you please post solution for " N balloon burst problem in leetcode"?
@giorgi23
@giorgi23 3 года назад
Thanks man. Using your idea I wrote this code. We can avoid sorting and if/else condition public int coinChange(int[] coins, int amount) { int[] dp = new int[amount + 1]; Arrays.fill(dp, amount + 1); dp[0] = 0; for (int c : coins) { for (int i = c; i amount ? -1 : dp[amount]; }
@TZCoder
@TZCoder 4 года назад
This is the first video that makes sense, why does every other video talk about building a coins* amount memo table?
@nagavedareddy5891
@nagavedareddy5891 2 года назад
Great explanation :)
@johnangelo2000
@johnangelo2000 2 года назад
why i = 0 not 1? dp[0] is already min...isn't?
@codegeek8256
@codegeek8256 2 года назад
What does dp mean?
@mrbobcat7399
@mrbobcat7399 2 года назад
dynamic programming
@blaisemuhirwa7806
@blaisemuhirwa7806 4 года назад
Nice explanations!
@friendsforevere3637
@friendsforevere3637 5 лет назад
Hey can u make a video on minesweeper and tic tac toe too ? It would be helpful and greatly appreciated.
@sars-cov-2611
@sars-cov-2611 3 года назад
I think I figured out an even faster solution. Given that you have an infinite number of each coins, you don't need to work a tech job, hell you don't need to work at all. 0ms and 0mb, faster than 100%.
@nosoyyotampoco
@nosoyyotampoco 4 года назад
After added the else break, some answers are wrong
@chenyangwang7232
@chenyangwang7232 4 года назад
I believe new test cases were added made this logic is incorrect?
@ej9806
@ej9806 5 лет назад
You're so good at solving leetcodes! Why don't you work for a FANG company since you can obviously pass their interviews, is it because you prefer working at a smaller company?
@chenyangwang7232
@chenyangwang7232 4 года назад
why everyone must work at FANG if they are good at leetcode?
@juicee235
@juicee235 4 года назад
Great explanation!
@KevinNaughtonJr
@KevinNaughtonJr 4 года назад
thanks! If you like my explanations be sure to join the interviewing service I created thedailybyte.dev/?ref=kevin I recommend joining a premium plan if you can!
@studyaccount794
@studyaccount794 2 года назад
Amazing solution. It was way easeir than leetcode's solution. Thanks man!!
@RishabhVerma
@RishabhVerma 5 лет назад
Can you please explain solution of diagonal traverse of 2D array? Leetcode 498
@vasanthkannan3398
@vasanthkannan3398 2 года назад
I can't understand it, man.
@doruwyl
@doruwyl 5 лет назад
As additional explanation I suggest this video: ru-vid.com/video/%D0%B2%D0%B8%D0%B4%D0%B5%D0%BE-jgiZlGzXMBw.html from Back to Back SWE.
@lauaurora66
@lauaurora66 5 лет назад
dude, u are legend !
@AmolGautam
@AmolGautam 5 лет назад
Thank you so much
@alirezaRahmanikhalili
@alirezaRahmanikhalili 4 года назад
good job
@harrypotter-ku4lf
@harrypotter-ku4lf 3 года назад
Kevin, This is my C++ implementation. Any comment? Thanks int CointChange(std::vector& coins, int amount) { std::sort(coins.begin(), coins.end(), std::greater()); for (auto a : coins) { if (amount % a) return amount / a; if (std::find(coins.begin(), coins.end(), (amount % a)) != coins.end()) return (amount / a) + 1; } return -1; }
@harrypotter-ku4lf
@harrypotter-ku4lf 3 года назад
if (amount % a == 0)
@ahmedbrhili1965
@ahmedbrhili1965 3 года назад
nuts explnation
@anshuman5554
@anshuman5554 5 лет назад
Can you do the solution in c++? That will be very much helpful
@notwhoyouthink666
@notwhoyouthink666 5 лет назад
lol, you just copy-paste solutions from leetcode :D
@algoseekee
@algoseekee 5 лет назад
probably copied but not pasted, typed once again ;-)
@notwhoyouthink666
@notwhoyouthink666 5 лет назад
Lol
@fsfdsdfdsfsdf
@fsfdsdfdsfsdf 5 лет назад
@@notwhoyouthink666 I mean he explains it in an easy-to-understand manner thats helpful to people when a solution article might not be
@roblevintennis
@roblevintennis 4 года назад
@Josh Ribakoff greedy doesn't work certain when certain coin denominations applied against certain amounts so it's an unreliable approach. Also, by tabulating the previous results into an array the presented solution is indeed DP. DP is either recursion + memoization, or, tabulation, and he used the later. Cheers.
@roblevintennis
@roblevintennis 4 года назад
Here's decent explanation on the greedy solution issue: ru-vid.com/video/%D0%B2%D0%B8%D0%B4%D0%B5%D0%BE-rdI94aW6IWw.html
Далее
House Robber
7:32
Просмотров 85 тыс.
That was too fast! 😲
01:00
Просмотров 6 млн
Reorganize String
12:44
Просмотров 78 тыс.
Longest Common Prefix
10:35
Просмотров 76 тыс.
Partition Equal Subset Sum
16:51
Просмотров 78 тыс.
Unique Paths
7:07
Просмотров 60 тыс.
Coin Change Problem (Recursion)
14:17
Просмотров 48 тыс.